<?php

//
//  HPivot.php
//	managenment multiple pages in one session
//	$Id: HPivot.php,v 1.1 2002/02/06 12:51:18 koyama Exp $
//

require_once('HSession.php');

class HPivot {
  var $params;
  var $cur_pos;		// ߰
  var $default_pos;	// ֤ΰ

  var $session;		// HSession֥
  var $session_level;	// HSessionϿ٥
  var $pos_name;	// ֤߰򥻥åϿ̾
  var $check_key_name;	// check_key򥻥åϿ̾

  var $cur_check_key;	// ߤcheck_key

  // 󥹥ȥ饯
  //  $options ϰʲͤ
  //  $options = array(
  //	array(position_tag, path, check_path, next_position),
  //	array(position_tag, path, check_path, next_position),
  //		:
  //
  function HPivot($options = '',
  		  $session = '',
		  $session_level = HSLV_LOCAL,
  		  $pos_name = 'HPivot_position',
  		  $check_key_name = false) {

    if ($options != '') {
      foreach ($options as $opt) {
	list($pos, $path, $checkpath, $next) = $opt;
	$this->set($pos, $path, $checkpath, $next);
      }
    }
    if ($session != '') {
      $this->session = $session;
    }
    if ($session_level != '') {
      $this->session_level = $session_level;
    }

    if ($pos_name != '') {
      $this->pos_name = $pos_name;
    }

    if ($check_key_name) {
      $this->check_key_name = $check_key_name;
    } else {
      // default rule.
      $this->check_key_name = 'check_key_' . $this->pos_name;
    }
  }

  // ֤ΰ֤
  function setDefaultPosition($pos) {
    $this->default_pos = $pos;
  }

  // ưѥ᡼¸
  function set($pos, $path, $checkpath, $next) {
    $this->params[$pos] = array($path, $checkpath, $next);
  }

  // ưѥ᡼
  function getParam($pos) {
    return $this->params[$pos];
  }

  // ֤ɽѥե̾
  function getPath($pos) {
    $param = $this->getParam($pos);
    if ($param != '') {
      list($path,,) = $param;
    }
    return $path;
  }

  // ֤åѥե̾
  function getCheckPath($pos) {
    $param = $this->getParam($pos);
    if ($param != '') {
      list(, $checkPath,) = $param;
    }
    return $checkPath;
  }

  // ΰ֤
  function getNextPosition($pos = '') {
    if ($pos == '') {
      $pos = $this->getPosition();
    }
    $param = $this->getParam($pos);
    if ($param != '') {
      list(,, $next) = $param;
    }
    return $next;
  }

  // ΰ֤
  function getPrevPosition($pos = '') {
    if ($pos == '')
      $pos = $this->getPosition();
    $pos--;
    if ($pos <= 0)
      $pos = -1;
    return $pos;
  }

  // ֤߰
  function setPosition($pos) {
    $this->cur_pos = $pos;
  }

  // ֤߰
  function getPosition() {
    return $this->cur_pos;
  }

  // ߤɽѥե̾
  function getCurPath() {
    return $this->getPath($this->cur_pos);
  }

  // ߤΥåѥե̾
  function getCurCheckPath() {
    return $this->getCheckPath($this->cur_pos);
  }

  // ΰ֤ɽѥե̾
  function getNextPath() {
    $next = $this->getNextPosition($this->getPosition());
    return $this->getPath($next);
  }

  // ᤹ͤ
  function prev() {
    $prev = $this->getPrevPosition($this->getPosition());
    if ($prev <= 0)
      return -1;
    $this->setPosition($prev);
    return $this->getPosition();
  }

  // ֤߰ʤ
  function next() {
    $next = $this->getNextPosition($this->getPosition());
    $this->setPosition($next);
    return $this->getPosition();
  }

  // ¹
  function run($check_key) {
    $this->cur_check_key = $check_key;

    // ХѿؿǤ⥰ХȤư褦ˤ
    foreach ($GLOBALS as $name => $val) {
      // PHPåȤΤϽ
      if ((substr($name, 0, 1) != '_') && !preg_match('/^HTTP/', $name)) {
	global $$name;
      }
    }

    $pos_name = $this->pos_name;
    $tsession = $this->session;

    $pos = $tsession->getVar($pos_name);
    if (empty($pos) || ($this->getParam($pos) == ''))
      $pos = $this->default_pos;

    $this->setPosition($pos);

    $_check = $tsession->getVar($this->check_key_name);
    if (array_key_exists($this->check_key_name, $_POST))
      $check = $_POST[$this->check_key_name];
    else
      $check = null;

    $checkOk = false;
    if (isset($check) && ($check == $_check)) {
      $checkpath = $this->getCurCheckPath();
      if ($checkpath != "")
	include($checkpath);
      else
	$checkOk = true;
    }

    // $checkOk is set in $checkpath
    if ($checkOk) {
      if ($this->next() == 0) {
	return 0;
      }
    }
    $pos = $this->getPosition();
    $tsession->setVar($pos_name, $pos, $this->session_level);
    $tsession->setVar($this->check_key_name, $check_key, $this->session_level);

    return $pos;
  }

  // check_keyHTMLिʸ
  function embed() {
    return '<input type="hidden" name="' .
      $this->check_key_name .
      '" value="' .
      $this->cur_check_key .
      '">';
  }
}

?>
